package com.wd.workoffice.ui.activity.mes.user;

import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.alibaba.fastjson.JSON;
import com.chad.library.adapter.base.BaseQuickAdapter;
import com.wd.workoffice.R;
import com.wd.workoffice.app.BaseBean;
import com.wd.workoffice.app.BaseMesBean;
import com.wd.workoffice.app.WorkToolBarActivity;
import com.wd.workoffice.bean.AccountBean;
import com.wd.workoffice.bean.mesBean.MchineDetailBean;
import com.wd.workoffice.bean.mesBean.UserDataDetailBean;
import com.wd.workoffice.retrofit.RtfUtils;
import com.wd.workoffice.retrofit.WorkObserver;
import com.wd.workoffice.ui.adapter.UserDataMachineAdapter;
import com.wd.workoffice.util.WorkUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import flexible.xd.android_base.network.rtfhttp.Transformer;
import flexible.xd.android_base.utils.TimeUtils;
import io.reactivex.disposables.Disposable;

/**
 * 用户数据采集，
 * author : flexible
 * email : lgd19940421@163.com
 * github: https://github.com/FlexibleXd
 **/
public class MesUserDataDetailActivity extends WorkToolBarActivity {
    RelativeLayout rlGoMiddle;
    @BindView(R.id.btn_refuse)
    Button btnRefuse;
    @BindView(R.id.btn_reviews)
    Button btnReviews;
    @BindView(R.id.ll_bottom)
    LinearLayout llBottom;
    @BindView(R.id.tv_reason)
    TextView tvReason;
    @BindView(R.id.ll_reason)
    LinearLayout llReason;
    @BindView(R.id.iv_modify_client)
    ImageView ivModifyClient;
    @BindView(R.id.tv_client)
    TextView tvClient;
    @BindView(R.id.rl_client)
    RelativeLayout rlClient;
    @BindView(R.id.tv_sale)
    TextView tvSale;
    @BindView(R.id.tv_manager)
    TextView tvManager;
    @BindView(R.id.iv_modify_steel)
    ImageView ivModifySteel;
    @BindView(R.id.tv_factory)
    TextView tvFactory;
    @BindView(R.id.tv_num)
    TextView tvNum;
    @BindView(R.id.tv_type)
    TextView tvType;
    @BindView(R.id.rv_factory_data1)
    RecyclerView rvFactoryData1;
    @BindView(R.id.rv_factory_data2)
    RecyclerView rvFactoryData2;
    @BindView(R.id.rv_factory_data3)
    RecyclerView rvFactoryData3;
    @BindView(R.id.iv_modify_machine)
    ImageView ivModifyMachine;
    @BindView(R.id.tv_machine_type)
    TextView tvMachineType;
    @BindView(R.id.tv_section)
    TextView tvSection;
    @BindView(R.id.tv_steel_type)
    TextView tvSteelType;
    @BindView(R.id.tv_speed)
    TextView tvSpeed;
    @BindView(R.id.rl_middle)
    RelativeLayout rlMiddle;
    @BindView(R.id.tv_middle1)
    TextView tvMiddle1;
    @BindView(R.id.tv_middle2)
    TextView tvMiddle2;
    @BindView(R.id.tv_middle3)
    TextView tvMiddle3;
    @BindView(R.id.tv_middle4)
    TextView tvMiddle4;
    @BindView(R.id.tv_middle5)
    TextView tvMiddle5;
    @BindView(R.id.tv_middle6)
    TextView tvMiddle6;
    @BindView(R.id.tv_middle7)
    TextView tvMiddle7;
    @BindView(R.id.tv_middle8)
    TextView tvMiddle8;
    @BindView(R.id.ll_middle)
    LinearLayout llMiddle;
    @BindView(R.id.rl_cover)
    RelativeLayout rlCover;
    @BindView(R.id.tv_cover1)
    TextView tvCover1;
    @BindView(R.id.tv_cover2)
    TextView tvCover2;
    @BindView(R.id.tv_cover3)
    TextView tvCover3;
    @BindView(R.id.tv_cover4)
    TextView tvCover4;
    @BindView(R.id.ll_cover)
    LinearLayout llCover;
    @BindView(R.id.rl_protection)
    RelativeLayout rlProtection;
    @BindView(R.id.tv_protection1)
    TextView tvProtection1;
    @BindView(R.id.tv_protection2)
    TextView tvProtection2;
    @BindView(R.id.tv_protection3)
    TextView tvProtection3;
    @BindView(R.id.tv_protection4)
    TextView tvProtection4;
    @BindView(R.id.ll_protection)
    LinearLayout llProtection;
    @BindView(R.id.rv_data1)
    RecyclerView rvData1;
    @BindView(R.id.tv_add1)
    TextView tvAdd1;
    @BindView(R.id.rv_data2)
    RecyclerView rvData2;
    @BindView(R.id.rv_data3)
    RecyclerView rvData3;
    @BindView(R.id.tv_add3)
    TextView tvAdd3;
    @BindView(R.id.rv_data4)
    RecyclerView rvData4;
    @BindView(R.id.tv_add4)
    TextView tvAdd4;
    @BindView(R.id.rl_add)
    RelativeLayout rlAdd;
    private AccountBean dataBean;
    private UserDataMachineAdapter data1Adapter;
    private UserDataMachineAdapter data2Adapter;
    private UserDataMachineAdapter data3Adapter;
    private UserDataMachineAdapter data4Adapter;
    private MchineDetailBean machineDetailBean;
    private List<String> data1List;
    private List<String> data2List;
    private List<String> data3List;
    private List<String> data4List;

    @Override
    protected void initView() {
        ButterKnife.bind(this);
        if (TextUtils.equals("1", getIntent().getStringExtra("from"))) {
            llBottom.setVisibility(View.VISIBLE);
        }
        rvData1.setLayoutManager(new LinearLayoutManager(this, RecyclerView.VERTICAL, false));
        rvData2.setLayoutManager(new LinearLayoutManager(this, RecyclerView.VERTICAL, false));
        rvData3.setLayoutManager(new LinearLayoutManager(this, RecyclerView.VERTICAL, false));
        rvData4.setLayoutManager(new LinearLayoutManager(this, RecyclerView.VERTICAL, false));
    }

    @Override
    protected void initData() {
        data1List = new ArrayList<>();
        data2List = new ArrayList<>();
        data3List = new ArrayList<>();
        data4List = new ArrayList<>();
        data1Adapter = new UserDataMachineAdapter(R.layout.item_machine, data1List);
        data2Adapter = new UserDataMachineAdapter(R.layout.item_machine, data2List);
        data3Adapter = new UserDataMachineAdapter(R.layout.item_machine, data3List);
        data4Adapter = new UserDataMachineAdapter(R.layout.item_machine, data4List);
        data1Adapter.bindToRecyclerView(rvData1);
        data2Adapter.bindToRecyclerView(rvData2);
        data3Adapter.bindToRecyclerView(rvData3);
        data4Adapter.bindToRecyclerView(rvData4);
        getData();
    }

    private void getData() {
        Map<String, Object> param = WorkUtils.simpleParam();
        param.put("id", getIntent().getStringExtra("id"));
        RtfUtils.getMesRtf().userDataDetail("1", WorkUtils.convertMapToBody(param)).compose(Transformer.schedule()).subscribe(new WorkObserver<BaseMesBean>() {
            @Override
            public void doOnSubscribe(Disposable d) {
            }

            @Override
            public void onFail(String errorMsg) {
                hideLoading();
                toast(errorMsg);
            }

            @Override
            public void onSuccess(BaseMesBean data) {
                hideLoading();
                if (!data.isSuccess()) {
                    toast(data.getMsg());
                    return;
                }
                UserDataDetailBean userDataDetailBean = JSON.parseObject(data.getData().toString(), UserDataDetailBean.class);
                UserDataDetailBean.MainInfoBean mainInfo = userDataDetailBean.getMainInfo();
                if (mainInfo != null) {
                    tvClient.setText(mainInfo.getCustomerUserName());
                    tvManager.setText(mainInfo.getSalesManagerName());
                    tvSale.setText(mainInfo.getSalesCompanyName());
                }
                getMachineData(userDataDetailBean.getSteelInfo().getContinuousCasterCode());
            }
        });
    }

    private void getMachineData(String code) {
        Map<String, Object> param = WorkUtils.simpleParam();
        param.put("continuousCasterCode", code);
        RtfUtils.getMesRtf().machineDetail("1", WorkUtils.convertMapToBody(param)).compose(Transformer.schedule()).subscribe(new WorkObserver<BaseMesBean>() {
            @Override
            public void doOnSubscribe(Disposable d) {
            }

            @Override
            public void onFail(String errorMsg) {
                hideLoading();
                toast(errorMsg);
            }

            @Override
            public void onSuccess(BaseMesBean data) {
                hideLoading();
                if (!data.isSuccess()) {
                    toast(data.getMsg());
                    return;
                }
                machineDetailBean = JSON.parseObject(data.getData().toString(), MchineDetailBean.class);
                MchineDetailBean.CastInfoBean castInfo = machineDetailBean.getCastInfo();
                if (castInfo != null) {
                    tvMachineType.setText(castInfo.getContinuousCasterName());
                    tvSection.setText(castInfo.getFractureSurface());
                    tvSteelType.setText(castInfo.getSteelGrade());
                    tvSpeed.setText(castInfo.getCastingSpeed());
                }
                MchineDetailBean.CastLadleBean castLadle = machineDetailBean.getCastLadle();
                if (castLadle != null) {
                    tvMiddle1.setText(castLadle.getCapacity());
                    tvMiddle2.setText(castLadle.getLifeSpan());
                    tvMiddle3.setText(castLadle.getLadleCode());
                    tvMiddle4.setText(castLadle.getLiquidLevel());
                    tvMiddle5.setText(castLadle.getLiquidSteelTemperature());
                    tvMiddle6.setText(castLadle.getBakingMethod());
                    tvMiddle7.setText(castLadle.getBakingTemperature());
                    tvMiddle8.setText(TimeUtils.millis2String(castLadle.getBakingDateTime()));
                }
                MchineDetailBean.CovAgentBean covAgent = machineDetailBean.getCovAgent();
                if (covAgent != null) {
                    tvCover1.setText(covAgent.getLadleCoveringAgentName());
                    tvCover2.setText(covAgent.getAcidAlkaliDegree());
                    tvCover3.setText(covAgent.getChemicalComposition());
                    tvCover4.setText(covAgent.getSupplierName());
                }
                MchineDetailBean.MouldFluBean mouldFlu = machineDetailBean.getMouldFlu();
                if (mouldFlu != null) {
                    tvProtection1.setText(mouldFlu.getMouldFluxesName());
                    tvProtection2.setText(mouldFlu.getAcidAlkaliDegree());
                    tvProtection3.setText(mouldFlu.getChemicalComposition());
                    tvProtection4.setText(mouldFlu.getSupplierName());
                }
                changeList();


            }
        });
    }

    private void changeList() {
        data1List.clear();
        data2List.clear();
        data3List.clear();
        data4List.clear();
        if (machineDetailBean.getProductList() != null) {
            for (MchineDetailBean.ProductListBean productListBean : machineDetailBean.getProductList()) {
                data1List.add(productListBean.getProductsName());
            }
            data1Adapter.notifyDataSetChanged();
        }
        if (machineDetailBean.getSupplyList() != null) {
            for (MchineDetailBean.SupplyListBean productListBean : machineDetailBean.getSupplyList()) {
                data2List.add(productListBean.getProductsName());
            }
            data2Adapter.notifyDataSetChanged();
        }
        if (machineDetailBean.getOtherSupList() != null) {
            for (MchineDetailBean.OtherSupListBean productListBean : machineDetailBean.getOtherSupList()) {
                data3List.add(productListBean.getSupplierName());
            }
            data3Adapter.notifyDataSetChanged();
        }
        if (machineDetailBean.getOtherLadleList() != null) {
            for (MchineDetailBean.OtherLadleListBean productListBean : machineDetailBean.getOtherLadleList()) {
                data4List.add(productListBean.getRefractoryName());
            }
            data4Adapter.notifyDataSetChanged();
        }
    }

    @Override
    protected void initEvent() {
        data1Adapter.setOnItemClickListener(new BaseQuickAdapter.OnItemClickListener() {
            @Override
            public void onItemClick(BaseQuickAdapter adapter, View view, int position) {
                startActivity(MesThreeModifyActivity.class);
            }
        });
        data2Adapter.setOnItemClickListener(new BaseQuickAdapter.OnItemClickListener() {
            @Override
            public void onItemClick(BaseQuickAdapter adapter, View view, int position) {
                startActivity(MesSupplierActivity.class);
            }
        });
        data3Adapter.setOnItemClickListener(new BaseQuickAdapter.OnItemClickListener() {
            @Override
            public void onItemClick(BaseQuickAdapter adapter, View view, int position) {
                startActivity(MesOtherSupplierModifyActivity.class);
            }
        });
        data4Adapter.setOnItemClickListener(new BaseQuickAdapter.OnItemClickListener() {
            @Override
            public void onItemClick(BaseQuickAdapter adapter, View view, int position) {
                startActivity(MesPackageModifyActivity.class);
            }
        });
    }

    @Override
    protected int layoutId() {
        return R.layout.activity_mes_user_data_detail;
    }


    @OnClick({R.id.tv_add1, R.id.tv_add3, R.id.tv_add4, R.id.rl_add})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.tv_add1:
                startActivity(MesThreeAddActivity.class);
                break;
            case R.id.tv_add3:
                startActivity(MesOtherSupplierAddActivity.class);
                break;
            case R.id.tv_add4:
                startActivity(MesPackageAddActivity.class);
                break;
            case R.id.rl_add:
                startActivity(MesMiddleAddActivity.class);
                break;
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // TODO: add setContentView(...) invocation
        ButterKnife.bind(this);
    }
}
